
# CMake module to search for QTUIO library
#
# If it's found it sets QTUIO_FOUND to TRUE
# and following variables are set:
#    QTUIO_INCLUDE_DIR
#    QTUIO_LIBRARY


FIND_PATH(QTUIO_INCLUDE_DIR qtuio.h 
  /usr/local/include/qTUIO 
  /usr/include/qTUIO 
  c:/msys/local/include/qTUIO
  #MSVC
  C:/dev/cpp/qtuio
  )

FIND_LIBRARY(QTUIO_LIBRARY NAMES qTUIO PATHS 
  /usr/local/lib 
  /usr/lib 
  c:/msys/local/lib
  #MSVC
  C:/dev/cpp/qtuio
  )

IF (QTUIO_INCLUDE_DIR AND QTUIO_LIBRARY)
   SET(QTUIO_FOUND TRUE)
ENDIF (QTUIO_INCLUDE_DIR AND QTUIO_LIBRARY)


IF (QTUIO_FOUND)

   IF (NOT QTUIO_FIND_QUIETLY)
      MESSAGE(STATUS "Found QTUIO: ${QTUIO_LIBRARY}")
   ENDIF (NOT QTUIO_FIND_QUIETLY)

ELSE (QTUIO_FOUND)

   IF (QTUIO_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "Could not find QTUIO")
   ENDIF (QTUIO_FIND_REQUIRED)

ENDIF (QTUIO_FOUND)
