#include "qgismt.h"

#include <qgisinterface.h>

#include <QDebug>

#ifdef WIN32
#define QGISEXTERN extern "C" __declspec( dllexport )
#else
#define QGISEXTERN extern "C"
#endif

QGisMT* QGisMT::mInstance = 0;

QGisMT::QGisMT(QgisInterface* iface):mIface(iface),mAction(0)
{
    
   mLegendIface = mIface->legendInterface();
 
    mInstance = this;
}

QGisMT::~QGisMT()
{
    delete window;
}

void QGisMT::initGui()
{
    mAction = new QAction(tr("&QGisMT"), this);
    connect(mAction, SIGNAL(activated()), this, SLOT(actionPlugin()));
    mIface->addToolBarIcon(mAction);
    mIface->addPluginToMenu(tr("&QGisMT"), mAction);
    window = new QGisMTWindow(mIface);
    window->hide();
    tuio.start();
    qDebug()<< "Loaded : qgismt";
    //AutoStart Plugins Window 
    QTimer *timer = new QTimer(this);
    timer->setSingleShot(true);
    connect(timer,SIGNAL(timeout()),this,SLOT(actionPlugin()));
    timer->start(1000);
}

void QGisMT::unload()
{
    mIface->removeToolBarIcon(mAction);
    mIface->removePluginMenu(tr("&Convert to point"), mAction);
    delete mAction;
    
}

void QGisMT::actionPlugin()
{
    window->showFullScreen();
}

QIcon QGisMT::getThemeIcon(const QString name)
{
  return QIcon();
}

QPixmap QGisMT::getThemePixmap(const QString name)
{
  return QPixmap();
}



QGISEXTERN QgisPlugin* classFactory(QgisInterface* iface)
{
    return new QGisMT(iface);
}
QGISEXTERN QString name()
{
    return "MultiTouch Interface plugin";
}
QGISEXTERN QString description()
{
    return "A plugin that allow to use a touchscreen as input device to control QGis";
}
QGISEXTERN QString version()
{
    return "0.02";
}
// Return the type (either UI or MapLayer plugin)
QGISEXTERN int type()
{
    return QgisPlugin::UI;
}
// Delete ourself
QGISEXTERN void unload(QgisPlugin* theQGisMTPluginPointer)
{

    delete theQGisMTPluginPointer;
}


#ifdef USECMAKE
#include "qgismt.moc"
#endif
