#include <QDebug>
#include <QApplication>
#include <QWidget>
#include <QDesktopWidget>
#include "qtuio.h"


//------------------
QTuio::QTuio(QObject *parent) {}

//------------------
QTuio::~QTuio() {}

void QTuio::start() {
    m_client.addTuioListener(this);
    qDebug()<<"start client tuio";
    m_client.connect(false);
    if (m_client.isConnected())
    {
        qDebug()<<"client est connecte";
    } else
    {
        qDebug()<<"client n'est pas connecte";
    }

}
void QTuio::run() {
    m_client.addTuioListener(this);
    qDebug()<<"start client tuio";
    m_client.connect(false);
    if (m_client.isConnected())
    {
        qDebug()<<"client est connecte";
    } else
    {
        qDebug()<<"client n'est pas connecte";
    }


}
//------------------
void QTuio::addTuioCursor(TUIO::TuioCursor * tcur)
{
    //qDebug()<<" add tui cursor";
    translateRawTouchEvent( 0, QTouchEvent::TouchScreen, getCurrentTouchPointList(tcur));
}

//------------------
void QTuio::updateTuioCursor(TUIO::TuioCursor *tcur)
{
    //qDebug()<<" update tui cursor";
    translateRawTouchEvent( 0, QTouchEvent::TouchScreen, getCurrentTouchPointList(tcur));
}

//------------------
void QTuio::removeTuioCursor(TUIO::TuioCursor *tcur)
{
    //qDebug()<<" remove tui cursor";
    translateRawTouchEvent( 0, QTouchEvent::TouchScreen, getCurrentTouchPointList(tcur));
}


//------------------


QList<QTouchEvent::TouchPoint> QTuio::getCurrentTouchPointList(TUIO::TuioCursor *tcur)
{
    static QRect screenRect = QApplication::desktop()->screenGeometry();
    QMap<int, QTouchEvent::TouchPoint> touchPoints;
    std::list<TUIO::TuioCursor *> cursors = m_client.getTuioCursors();
    m_client.lockCursorList();
    for (std::list<TUIO::TuioCursor*>::iterator iter = cursors.begin(); iter!=cursors.end(); iter++) {
        TUIO::TuioCursor *cur = (*iter);
        QTouchEvent::TouchPoint p(cur->getCursorID());


        //PRESSURE
        p.setScreenPos(QPointF(cur->getScreenX(screenRect.width()), cur->getScreenY(screenRect.height())));
        p.setPressure(0.1);

        int state = cur->getTuioState();
        if (state == TUIO_ADDED)
        {
            p.setState(Qt::TouchPointPressed);
        }
        else if (state== TUIO_REMOVED)
        {
            p.setState(Qt::TouchPointReleased);
        }
        else if (state == TUIO_STOPPED)
        {
            p.setState(Qt::TouchPointStationary);
        }
        else if (state == TUIO_ACCELERATING || state == TUIO_DECELERATING)
        {
            p.setState(Qt::TouchPointMoved);
        }

        touchPoints.insert(p.id(), p);

    }
    m_client.unlockCursorList();

    if (!touchPoints.contains(tcur->getCursorID()))
    {
        qDebug()<< "getCurrentTouchPointList " << "tcur is not contained";
    }





    return touchPoints.values();
}


//------------------
void QTuio::translateRawTouchEvent(QWidget *window,
                                   QTouchEvent::DeviceType deviceType,
                                   const QList<QTouchEvent::TouchPoint> &touchPoints)
{
    //qDebug()<<"translateRawTouchEvent";
    //QApplicationPrivate *d = self;
    typedef QPair<Qt::TouchPointStates, QList<QTouchEvent::TouchPoint> > StatesAndTouchPoints;
    QHash<QWidget *, StatesAndTouchPoints> widgetsNeedingEvents;

    for (int i = 0; i < touchPoints.count(); ++i) {
        QTouchEvent::TouchPoint touchPoint = touchPoints.at(i);

        // update state
        QWidget *widget = 0;
        switch (touchPoint.state()) {
        case Qt::TouchPointPressed:
        {
            //if (deviceType == QTouchEvent::TouchPad) {
            //    // on touch-pads, send all touch points to the same widget
            //    widget = d->widgetForTouchPointId.isEmpty()
            //             ? 0
            //             : d->widgetForTouchPointId.constBegin().value();
            //}

            if (!widget) {
                // determine which widget this event will go to
                if (!window)
                    window = QApplication::topLevelAt(touchPoint.screenPos().toPoint());
                if (!window)
                    continue;
                widget = window->childAt(window->mapFromGlobal(touchPoint.screenPos().toPoint()));
                if (!widget)
                    widget = window;
            }
//cette histoire du plus proche ne me plait pas. je supprime. gilles
//            if (deviceType == QTouchEvent::TouchScreen) {
//                int closestTouchPointId = findClosestTouchPointId(touchPoint.screenPos());
//                QWidget *closestWidget = widgetForTouchPointId.value(closestTouchPointId);
//                if (closestWidget
//                    && (widget->isAncestorOf(closestWidget) || closestWidget->isAncestorOf(widget))) {
//                    widget = closestWidget;
//                }
//            }

            widgetForTouchPointId[touchPoint.id()] = widget;
            touchPoint.setStartScreenPos(touchPoint.screenPos());
            touchPoint.setLastScreenPos(touchPoint.screenPos());
            touchPoint.setStartNormalizedPos(touchPoint.normalizedPos());
            touchPoint.setLastNormalizedPos(touchPoint.normalizedPos());
            if (touchPoint.pressure() < qreal(0.))
                touchPoint.setPressure(qreal(1.));
            appCurrentTouchPoints.insert(touchPoint.id(), touchPoint);
            break;
        }
        case Qt::TouchPointReleased:
        {
            widget = widgetForTouchPointId.take(touchPoint.id());
            if (!widget)
                continue;

            QTouchEvent::TouchPoint previousTouchPoint = appCurrentTouchPoints.take(touchPoint.id());
            touchPoint.setStartScreenPos(previousTouchPoint.startScreenPos());
            touchPoint.setLastScreenPos(previousTouchPoint.screenPos());
            touchPoint.setStartNormalizedPos(previousTouchPoint.startNormalizedPos());
            touchPoint.setLastNormalizedPos(previousTouchPoint.normalizedPos());
            if (touchPoint.pressure() < qreal(0.))
                touchPoint.setPressure(qreal(0.));
            break;
        }
        default:
            widget = widgetForTouchPointId.value(touchPoint.id());
            if (!widget)
                continue;

            Q_ASSERT(appCurrentTouchPoints.contains(touchPoint.id()));
            QTouchEvent::TouchPoint previousTouchPoint = appCurrentTouchPoints.value(touchPoint.id());
            touchPoint.setStartScreenPos(previousTouchPoint.startScreenPos());
            touchPoint.setLastScreenPos(previousTouchPoint.screenPos());
            touchPoint.setStartNormalizedPos(previousTouchPoint.startNormalizedPos());
            touchPoint.setLastNormalizedPos(previousTouchPoint.normalizedPos());
            if (touchPoint.pressure() < qreal(0.))
                touchPoint.setPressure(qreal(1.));
            appCurrentTouchPoints[touchPoint.id()] = touchPoint;
            break;
        }
        Q_ASSERT(widget != 0);

        // make the *scene* functions return the same as the *screen* functions
        touchPoint.setSceneRect(touchPoint.screenRect());
        touchPoint.setStartScenePos(touchPoint.startScreenPos());
        touchPoint.setLastScenePos(touchPoint.lastScreenPos());

        StatesAndTouchPoints &maskAndPoints = widgetsNeedingEvents[widget];
        maskAndPoints.first |= touchPoint.state();
        if (touchPoint.isPrimary())
            maskAndPoints.first |= Qt::TouchPointPrimary;
        maskAndPoints.second.append(touchPoint);
    }

    if (widgetsNeedingEvents.isEmpty())
    {
        qDebug()<< "widgetsNeedingEvents.isEmpty()";
        return;
    }

    QHash<QWidget *, StatesAndTouchPoints>::ConstIterator it = widgetsNeedingEvents.constBegin();
    const QHash<QWidget *, StatesAndTouchPoints>::ConstIterator end = widgetsNeedingEvents.constEnd();
    for (; it != end; ++it) {
        QWidget *widget = it.key();

        //if (!QApplicationPrivate::tryModalHelper(widget, 0))
        //    continue;

        QEvent::Type eventType;
        switch (it.value().first & Qt::TouchPointStateMask) {
        case Qt::TouchPointPressed:
            eventType = QEvent::TouchBegin;
            break;
        case Qt::TouchPointReleased:
            eventType = QEvent::TouchEnd;
            break;
        case Qt::TouchPointStationary:
            // don't send the event if nothing changed
            continue;
        default:
            eventType = QEvent::TouchUpdate;
            break;
        }

        //I am not allowed to call updateTouchPointsForWidget to update touchpoint pos.
        //So I make it manually
        QList<QTouchEvent::TouchPoint> pointsForWidget = it.value().second;
        QList<QTouchEvent::TouchPoint> pointsForEvent;
        for (int i =0; i< pointsForWidget.size(); i++)
        {
            QTouchEvent::TouchPoint touchPoint = pointsForWidget.at(i);
            // preserve the sub-pixel resolution
            QRectF rect = touchPoint.screenRect();
            const QPointF screenPos = rect.center();
            const QPointF delta = screenPos - screenPos.toPoint();

            rect.moveCenter(widget->mapFromGlobal(screenPos.toPoint()) + delta);
            touchPoint.setRect(rect);
            touchPoint.setStartPos(widget->mapFromGlobal(touchPoint.startScreenPos().toPoint()) + delta);
            touchPoint.setLastPos(widget->mapFromGlobal(touchPoint.lastScreenPos().toPoint()) + delta);
            pointsForEvent.push_back(touchPoint);
        }


        QTouchEvent *touchEvent= new QTouchEvent(eventType,
                deviceType,
                QApplication::keyboardModifiers(),
                it.value().first,
                pointsForEvent);//it.value().second);
        // gilles updateTouchPointsForWidget(widget, &touchEvent);

        switch (touchEvent->type()) {
        case QEvent::TouchBegin:
        {
            //this->displayTouchEvent(*touchEvent);
            // if the TouchBegin handler recurses, we assume that means the event
            // has been implicitly accepted and continue to send touch events
            widget->setAttribute(Qt::WA_WState_AcceptedTouchBeginEvent);
            //gilles problem thread safe (void ) QApplication::sendEvent(widget, &touchEvent);
            QApplication::postEvent(widget, touchEvent);
            break;
        }
        default:
            //displayTouchEvent(*touchEvent);
            if (widget->testAttribute(Qt::WA_WState_AcceptedTouchBeginEvent)) {
                if (touchEvent->type() == QEvent::TouchEnd)
                    widget->setAttribute(Qt::WA_WState_AcceptedTouchBeginEvent, false);
                //gilles problem thread safe(void) QApplication::sendEvent(widget, &touchEvent);
                (void) QApplication::postEvent(widget, touchEvent);
            }
            break;
        }
    }
}


#include <QStringList>
void QTuio::displayTouchEvent(const QTouchEvent &te)
{
    QStringList str;
    str<<"type= "<<QString::number(te.type());
    const QList<QTouchEvent::TouchPoint> points = te.touchPoints();
    for (int i = 0; i < points.size(); i++)
    {
        str<<" pt id="<<QString::number(points.at(i).id()) <<" x="<<QString::number(points.at(i).pos().x()) << " y="<<QString::number(points.at(i).pos().y()) ;
    }


    qDebug()<< str;
}











////-----------------------------
//void QTuio::updateTouchPointsForWidget(QWidget *widget, QTouchEvent *touchEvent)
//{
//    for (int i = 0; i < touchEvent->touchPoints().count(); ++i) {
//        QTouchEvent::TouchPoint &touchPoint = touchEvent->_touchPoints[i];
//
//        // preserve the sub-pixel resolution
//        QRectF rect = touchPoint.screenRect();
//        const QPointF screenPos = rect.center();
//        const QPointF delta = screenPos - screenPos.toPoint();
//
//        rect.moveCenter(widget->mapFromGlobal(screenPos.toPoint()) + delta);
//        touchPoint.setRect(rect);
//        touchPoint.setStartPos(widget->mapFromGlobal(touchPoint.startScreenPos().toPoint()) + delta);
//        touchPoint.setLastPos(widget->mapFromGlobal(touchPoint.lastScreenPos().toPoint()) + delta);
//    }
//}
#include "qtuio.moc"
