#ifndef QTuio_H
#define QTuio_H

#include <QObject>
#include <QTouchEvent>
#include <QDebug>
#include "tuio/TuioClient.h"
#include "tuio/TuioListener.h"
//#include "TUIO/TuioCursor.h"
//#include "TUIO/TuioObject.h"

class QTuio:public QObject, TUIO::TuioListener
{
    Q_OBJECT
public:
    static void displayTouchEvent(const QTouchEvent& te);


    QTuio(QObject *parent = 0);
    virtual ~QTuio();

    void start();
    void run();

    void stop(){m_client.disconnect();}

    virtual void addTuioObject(TUIO::TuioObject *){}
    virtual void updateTuioObject(TUIO::TuioObject *){}
    virtual void removeTuioObject(TUIO::TuioObject *){}
    virtual void refresh(TUIO::TuioTime){}
    virtual void addTuioCursor(TUIO::TuioCursor * cursor);
    virtual void updateTuioCursor(TUIO::TuioCursor *cursor);
    virtual void removeTuioCursor(TUIO::TuioCursor *cursor);



    //------------------
    //j'ai modifié updateTouhcPointsForWidget.
    //void updateTouchPointsForWidget(QWidget *widget, QTouchEvent *touchEvent);
    //int findClosestTouchPointId(const QPointF &screenPos);
    void translateRawTouchEvent(QWidget *window,
                                       QTouchEvent::DeviceType deviceType,
                                       const QList<QTouchEvent::TouchPoint> &touchPoints);
    //void initializeMultitouch();
    QList<QTouchEvent::TouchPoint> getCurrentTouchPointList(TUIO::TuioCursor *cur);

protected:
    TUIO::TuioClient m_client;

    //--------------------
    QMap<int, QWidget *> widgetForTouchPointId;
    QMap<int, QTouchEvent::TouchPoint> appCurrentTouchPoints;
};

#endif // QTuio_H
